//+------------------------------------------------------------------+
//|                                               SimpleFractals.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

//---- input parameters
extern double    Lots=0.1;
extern int       TakeProfit=20;
extern int       MagicNumber=555;

int FindOrder(int Type)
{
 int i = 0;
 while(i < OrdersTotal())
 {
  if(OrderSelect(i, SELECT_BY_POS))
   if(OrderMagicNumber() == MagicNumber && OrderSymbol() == Symbol() && OrderType() == Type)
     return(OrderTicket());
  i++;   
  }  
 return(-1);       
 }

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----

   double UpFractal = 0; 
   double DownFractal = 0;
   int NumUpFractal = 0, NumDownFractal = 0;

    //     
   double Spread = MarketInfo(Symbol(), MODE_SPREAD)*Point;
   double StopLevel = MarketInfo(Symbol(), MODE_STOPLEVEL)*Point;
   
// *******************************  1 .      *****************
   int i = 3;
   while((UpFractal == 0 || DownFractal == 0) && i<Bars)   
    {
     if(iFractals(Symbol(), 0, MODE_UPPER, i) != 0)
      if(UpFractal == 0)
       {
        UpFractal = iFractals(Symbol(), 0, MODE_UPPER, i);
        NumUpFractal = i;
        }
     if(iFractals(Symbol(), 0, MODE_LOWER, i) != 0)
      if(DownFractal == 0)
       {
        DownFractal = iFractals(Symbol(), 0, MODE_LOWER, i);
        NumDownFractal = i;
        }
     i++;   
     }
   if(UpFractal == 0 || DownFractal == 0)
    {
     Print("  .     !");
     return(0);
     }
   
  // ,       
   for(i = 0; i < NumUpFractal; i++)
    if(High[i] > UpFractal)
      UpFractal = 0;
   for(i = 0; i < NumDownFractal; i++)
    if(Low[i] < DownFractal)
      DownFractal = 0;
      
// ********************************   *****************************************************

// ********************************  2 .   Buy   BuyStop *************
   if(FindOrder(OP_BUYSTOP) > 0)
     {
      if(TakeProfit*Point > StopLevel)
        double TP = UpFractal+Spread+Point+TakeProfit*Point;
       else
        TP = 0; 
      //  Buy Stop 
      if(UpFractal != 0)
       if((OrderOpenPrice() <= UpFractal+Spread || OrderOpenPrice() >=UpFractal+Spread+2*Point) && UpFractal+Spread+Point-Ask > StopLevel)
        if(!OrderModify(OrderTicket(), UpFractal+Spread+Point, 0, TP,0))
         Print("    BuyStop.  ", GetLastError());
      }
    else
     if(FindOrder(OP_BUY) > 0)
       {
        //  Buy
        if(DownFractal != 0)
         if((OrderStopLoss() >= DownFractal || OrderStopLoss() <= DownFractal-2*Point) && Bid-DownFractal-Point > StopLevel)
          if(!OrderModify(OrderTicket(), 0, DownFractal-Point, OrderTakeProfit(), 0))
           Print("      Buy.  ", GetLastError());
        }     
      else
       if(Bid<UpFractal)
        {
         //  Buy-
         if(UpFractal+Spread+Point-Ask > StopLevel)
           double Price = UpFractal+Spread+Point;
          else
           Price = Ask+StopLevel; 
         if(TakeProfit*Point > StopLevel)
           TP = Price+TakeProfit*Point;
          else
           TP = 0; 
         if(OrderSend(Symbol(), OP_BUYSTOP, Lots, Price, 0, 0, TP, NULL, MagicNumber) == -1)
           Print("    BuyStop.  ", GetLastError()); 
         }  

// ********************************  2 . *****************************************************

// ********************************  3 .   Sell   SellStop *************
   if(FindOrder(OP_SELLSTOP) > 0)
     {
      if(TakeProfit*Point > StopLevel)
        TP = DownFractal-Point-TakeProfit*Point;
       else
        TP = 0; 
      //  Sell Stop 
      if(DownFractal != 0)
       if((OrderOpenPrice() <= DownFractal-2*Point || OrderOpenPrice() >= DownFractal) && Bid-DownFractal-Point > StopLevel)
        if(!OrderModify(OrderTicket(), DownFractal-Point, 0, TP,0))
          Print("    SellStop.  ", GetLastError());
      }
    else
     if(FindOrder(OP_SELL) > 0)
       {
        //  Sell
        if(UpFractal != 0)
         if((OrderStopLoss() <= UpFractal+Spread || OrderStopLoss() >= UpFractal+Spread+2*Point) && UpFractal+Spread+Point-Ask > StopLevel)
          if(!OrderModify(OrderTicket(), 0, UpFractal+Spread+Point, OrderTakeProfit(), 0))
           Print("      Sell.  ", GetLastError());
        }     
      else
       if(Bid>DownFractal && DownFractal != 0)
        {
         //  Sell-
         if(Bid-DownFractal-Point > StopLevel)
           Price = DownFractal-Point;
          else
           Price = Bid-StopLevel; 
         if(TakeProfit*Point > StopLevel)
           TP = Price-TakeProfit*Point;
          else
           TP = 0; 
         if(OrderSend(Symbol(), OP_SELLSTOP, Lots, Price, 0, 0, TP, NULL, MagicNumber) == -1)
           Print("    SellStop.  ", GetLastError()); 
         }  

// ********************************  3 . *****************************************************
//----
   return(0);
  }
//+------------------------------------------------------------------+